> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Swap - from Specified Amount

> This endpoint allows users to trade a specific amount of one token into another
token using the Aerodrome Slipstream protocol.

The transaction is executed by specifying the exact amount of the input token to be
sold, and the system calculates the amount of the output token that will be
received. The operation ensures that the trade is conducted within the constraints
of the current market conditions, taking into account the liquidity and price
impact. This endpoint is suitable for users who want to sell a precise quantity of a
token and are willing to accept the resulting amount of the other token.
                    <Info>
                    **Required Allowances**

                        In order to make this transaction, token allowances need to be set for the following contracts.

                     - `AerodromeSlipstreamRouter`
                    </Info>
                



## OpenAPI

````yaml /v1/combined_spec.json post /v1/aerodrome_slipstream/swap/sell_exactly
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v1/aerodrome_slipstream/swap/sell_exactly:
    post:
      tags:
        - Aerodrome Slipstream
      summary: Swap - from Specified Amount
      description: >-
        This endpoint allows users to trade a specific amount of one token into
        another

        token using the Aerodrome Slipstream protocol.


        The transaction is executed by specifying the exact amount of the input
        token to be

        sold, and the system calculates the amount of the output token that will
        be

        received. The operation ensures that the trade is conducted within the
        constraints

        of the current market conditions, taking into account the liquidity and
        price

        impact. This endpoint is suitable for users who want to sell a precise
        quantity of a

        token and are willing to accept the resulting amount of the other token.
                            <Info>
                            **Required Allowances**

                                In order to make this transaction, token allowances need to be set for the following contracts.

                             - `AerodromeSlipstreamRouter`
                            </Info>
                        
      operationId: v1_aerodrome_slipstream_swap_sell_exactly
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AerodromeSlipstreamSellExactlyRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.aerodrome_slipstream.aerodrome_slipstream_swap_sell_exactly(token_in="USDC", token_out="WETH", tick_spacing=100, amount_in=0.5, chain=models.AerodromeSlipstreamSellExactlyRequestChain.BASE, sender="0xED954266764e163cE73A0bC2aC717226cf73B03E", amount_out_minimum=0, estimate_gas=True)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.aerodromeSlipstream.aerodromeSlipstreamSwapSellExactly({
                tokenIn: "USDC",
                tokenOut: "WETH",
                tickSpacing: 100,
                amountIn: 0.5,
                amountOutMinimum: 0,
                chain: "base",
                sender: "0xED954266764e163cE73A0bC2aC717226cf73B03E",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    AerodromeSlipstreamSellExactlyRequest:
      properties:
        action_type:
          type: string
          const: AERODROME_SLIPSTREAM_SELL_EXACTLY
          title: Action Type
          default: AERODROME_SLIPSTREAM_SELL_EXACTLY
        token_in:
          type: string
          title: Token
          description: The symbol or address of the token to swap from.
          examples:
            - WETH
          default: USDC
        token_out:
          type: string
          title: Token
          description: The symbol or address of the token to swap to.
          examples:
            - WETH
          default: WETH
        tick_spacing:
          type: integer
          minimum: 1
          title: Tick Spacing
          description: The tick spacing of the pool
          examples:
            - 100
            - 300
            - 400
            - 500
            - 1000
            - 1500
            - 2500
            - 2700
            - 3000
            - 5000
            - 6000
            - 7000
            - 8000
            - 9000
            - 10000
            - 20000
          default: 100
        amount_in:
          anyOf:
            - type: number
              exclusiveMinimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount In
          description: The amount of the token to swap from
          examples:
            - 1.5
          default: 0.5
        amount_out_minimum:
          anyOf:
            - type: number
              minimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount Out Minimum
          description: The minimum amount of the token to swap to, defaults to 0
          default: '0'
          examples:
            - 1.4
        chain:
          type: string
          enum:
            - base
          title: Chain
          default: base
          examples:
            - base
        sender:
          type: string
          title: Sender
          description: The address of the transaction sender.
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0xED954266764e163cE73A0bC2aC717226cf73B03E'
        estimate_gas:
          type: boolean
          title: Estimate Gas
          description: >-
            Determines whether to estimate gas costs for transactions, also
            verifying that the transaction can be successfully executed.
          default: true
      type: object
      required:
        - token_in
        - token_out
        - tick_spacing
        - amount_in
        - chain
        - sender
      title: AerodromeSlipstreamSellExactlyRequest
      description: Request model for selling exactly an amount of tokens.
      default:
        chain: base
        sender: '0xED954266764e163cE73A0bC2aC717226cf73B03E'
        token_in: USDC
        token_out: WETH
        tick_spacing: 100
        amount_in: 0.5
        amount_out_minimum: 0
      required_allowances:
        - AerodromeSlipstreamRouter
    TransactionResponse:
      properties:
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - $ref: '#/components/schemas/UserOperationResponse'
          title: Transaction
          description: >-
            The unsigned transaction data. User must sign and broadcast to
            network.
      type: object
      required:
        - transaction
      title: TransactionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    UserOperationResponse:
      properties:
        to:
          type: string
          title: To
          description: The target contract address for the operation
        data:
          type: string
          title: Data
          description: The calldata for the operation
        value:
          type: string
          title: Value
          description: The ETH value to send with the operation
      type: object
      required:
        - to
        - data
        - value
      title: UserOperationResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````